function Fit = xacmes_evaluate(x)

global algo;
global settings;

npoints = size(x,2);
if (algo.realfunc == 1)     % using Real Fitness Function F(x)
    Fit = feval(settings.strfitnessfct, x);
    
    
    if (settings.withSurr == 1)
        for i=1:npoints
            algo.nevals = algo.nevals + 1;
            algo.iSZ = algo.iSZ + 1;
            algo.aSZ = algo.aSZ + 1;
            if (algo.aSZ > algo.maxArchSize)    
                algo.aSZ = algo.maxArchSize;
            end;
            if (algo.iSZ > algo.maxArchSize)    
                algo.iSZ = 1;
                if (0)
                    algo.iSZ = algo.aSZ;
                    algo.ARX(:,1) = [];
                    algo.ARF(1) = [];
                end;
            end

            algo.ARX(:,algo.iSZ) = x(:,i);  
            algo.ARF(algo.iSZ) = Fit(i);
            algo.ARneval(algo.iSZ) = algo.nevals;
        end;
    else
        algo.nevals = algo.nevals + npoints;
    end;
    [minFit,iminX] = min(Fit);
    if (minFit < algo.Fmin)
        algo.Fmin = minFit;
        algo.xmin = x(:,iminX);
    end;
end;   
if (algo.realfunc == 0)     % using Surrogate Fitness Function F^(x)
    global RSVM;

 	x_test = x;
  	Fit = -RankSVMFunc(RSVM.xtrainEncoded, x_test, npoints, RSVM.N, ... 
            RSVM.nTrain, RSVM.alphas, RSVM.TwoSigmaPow2, RSVM.invsqrtC, RSVM.Xmean_model, RSVM.doEncoding);  

    %if (1)
    %    for i=1:npoints
    %        x_test = x(:,i);
    %        Fit(i) = -RankSVMFunc(RSVM.xtrainEncoded, x_test, 1, RSVM.N, ... 
    %                                RSVM.nTrain, RSVM.alphas, RSVM.TwoSigmaPow2, RSVM.invsqrtC, RSVM.Xmean_model, RSVM.doEncoding);  
    %    end;
    %end;
end;
if (algo.realfunc == 2)     % using Model Quality Function H(theta)
    global optSVM;
    global algo;
    Fit = 0;
    nx = size(x,1);
    penalty = 0;
    correct = 1;
    for i=1:nx
        if (x(i) < 0)
            penalty = penalty + abs(0 - x(i));
        end;
        if (x(i) > 1)
            penalty = penalty + abs(1 - x(i));
        end;
        if (x(i) < 0.0) || (x(i) > 1.0)
            correct = 0;
        end;
    end;
    
    for i=1:nx
        maxV = optSVM.xmax(i);
        minV = optSVM.xmin(i);
        if (i == 1)
            if (maxV > algo.aSZ)
      %          max = algo.aSZ;
            end;
        end;
        coeff(i) = minV + x(i,1) * (maxV - minV);
    end;
    if (coeff(1) > algo.aSZ);
        penalty = coeff(1) - (algo.aSZ);
        correct = 0;
    end;
    
    if (correct == 0)
        Fit = 1 + penalty;
        return;
    end;

    model = xacmes_buildModel_RANKSVM(optSVM.algo_initial_state, coeff);
    
    %estimate f^(x) values 
    if (model.nCrossValidation == 0)
        model.CrossValidX = optSVM.CrossValidX;
        model.CrossValidF = optSVM.CrossValidF;
    else
        for i=1:optSVM.nCrossValidation
            model.CrossValidX(:,model.nCrossValidation + i) = optSVM.CrossValidX(:,i);
            model.CrossValidF(model.nCrossValidation + i) = optSVM.CrossValidF(i);
     	end;
    end;
    model.nCrossValidation = model.nCrossValidation + optSVM.nCrossValidation;
    
    err = xacmes_estimateModelError(model);
    
    Fit = err;
    
end;

